#ifndef __ONE_CYCLE
#define __ONE_CYCLE

#include "command/one_cycle_builder.js"
#include "command/commander.js"
#include "creator/create_table.js"
#include "max/remove_recursively.js"

Commander.OneCycle = function(index, vspacing) {
  var creator = Commander.OneCycleBuilder.create;

  this.CreateAndConnect = function(context) {
    context.define = Commander.OneCycleBuilder.define;
    this.objects = Creator.CreateTableEntry(creator, 0, vspacing, index, context);
    Max.Connect(Commander.OneCycleBuilder.connect, this.objects);
  };

  this.UpdateUI = function(cycle, is_edit) {
    var has_cycles = cycle.length > 1;
    this.objects.textedit.message('set', cycle.name || cycle);

    Max.Enable(this.objects.button.up, has_cycles);
    Max.Enable(this.objects.button.down, has_cycles);
    Max.Enable(this.objects.textedit, is_edit);
    Max.Enable(this.objects.button.add, is_edit);
    Max.Enable(this.objects.button.remove, is_edit);
  };

  this.Remove = function() {
    RemoveRecursively(this.objects);
  };
};

#endif  // __ONE_CYCLE
