#ifndef ONE_CYCLE_BUILDER
#define ONE_CYCLE_BUILDER

#include "command/commander.js"
#include "creator/builder.js"

var Extend = Creator.Builder.Extend;

Commander.OneCycleBuilder = {
  'define': {
    'button':
      ['live.text', 0, 0, 12, 12,
        ['activebgoncolor', [ 1.0, 1.0, 0.0, 1.0 ]],
        ['bgcolor', [ 0.858824, 0.858824, 0.858824, 1.0 ]],
        ['bordercolor', [1, 1, 1, 0]],
        ['mode', 0],
        ['presentation', 1],
      ],

    'arrow':
      Extend('button', 0, 0, ['activebgcolor', [1, 0.878431, 0.509804, 1]]),

    },

  'create': {
    'append':
      ['append #1', 27, 170, 65, 12, ['fontsize', 9]],

    'message': {
      'down':   ['message down',     8, 155, 32, 8, ['fontsize', 9]],
      'up':     ['message up',      -4, 150, 20, 8, ['fontsize', 9]],
      'add':    ['message add',    203, 150, 30, 8, ['fontsize', 9]],
      'remove': ['message remove', 214, 150, 46, 8, ['fontsize', 9]],
    },

    'button': {
      'up':
        Extend('arrow', 0, 1, ['varname', 'up.#1'], ['text', '↑'],
               ['activebgoncolor', [ 1.0, 1.0, 0.0, 1.0 ]]),

      'down':
        Extend('arrow', 13, 1, ['varname', 'down.#1'], ['text', '↓'],
               ['activebgoncolor', [ 1.0, 1.0, 0.0, 1.0 ]]),

      'add':
        Extend('button', 208, 1,
          ['varname', 'button.add.#1'],
          ['activebgcolor', [0.627451, 0.941176, 0.521569, 1]],
          ['text', '+'],
          ['fontsize', 14]
       ),

      'remove':
        Extend('button', 219, 1,
          ['activebgcolor', [1, 0.545098, 0.427451, 1]],
          ['fontface', 3],
          ['fontsize', 12],
          ['text', '-'],
          ['varname', 'button.remove.#1']
        ),
    },

    'textedit':
      ['textedit', 27, 0, 180, 14,
        ['border', 1],
        ['fontsize', 10],
        ['keymode', 1],
        ['lines', 1],
        ['outputmode', 1],
        ['presentation', 1],
        ['rounded', 0],
        ['wordwrap', 0],
      ],

  },

  'connect': [
    ['button.remove',  0, 'message.remove', 0],
    ['button.add',     0, 'message.add',    0],
    ['button.down',    0, 'message.down',   0],
    ['button.up',      0, 'message.up',     0],

    ['message.remove', 0, 'append', 0],
    ['message.add',    0, 'append', 0],
    ['message.down',   0, 'append', 0],
    ['message.up',     0, 'append', 0],
    ['textedit',       0, 'append', 0],

    ['append',       0, 'box', 0],
  ]
};

#endif  // ONE_CYCLE_BUILDER
