#ifndef __MAX_BUILDER
#define __MAX_BUILDER

#include "max/connect.js"
#include "creator/creator.js"
#include "creator/create.js"
#include "util/dict_utils.js"

Creator.CreateAndConnect = function(builder, context) {
  context.define = builder.define;
  var maxobjects = Creator.Create(builder.create, context);
  Max.Connect(builder.connect || [], maxobjects);

  return maxobjects;
};

Creator.Builder = function(builder) {
  if (typeof(builder) == 'string')
    builder = eval('(' + builder + ')', {Extend: Creator.Builder.Extend});

  return builder;
};

Creator.Builder.Extend = function(creator, x, y, _) {
  var msgs1 = arrayfromargs(arguments).slice(3);

  return function(context) {
    context = DictUtils.Copy(context);
    context.x += x;
    context.y += y;
    context.messages = Array.Concat(msgs1, context.messages);
    return Creator.Create(creator, context);
  };
};

#endif  // __MAX_BUILDER
