#ifndef __MAX_CREATE
#define __MAX_CREATE

#include "creator/create_object.js"

Creator.Create = function(creator, context) {
  if (context.define && creator in context.define)
    creator = context.define[creator];

  // Check if we failed to find a definition.
  if (typeof(creator) == 'string') {
    for (var n in context.define)
      post('define', n, context.define[n], '\n');
    throw new RangeError("Can't understand definition '" + creator + "'");
  }

  if (typeof(creator) == 'function')
    // If it's a function, we simply execute it.
    return creator(context);

  if (Array.Is(creator))
    // Arrays create a single Max object using CreateObject.
    return Creator.CreateObject(creator, context);

  // Otherwise, we call ourselves recursively and create a dictionary.
  var results = {};
  for (var name in creator)
    results[name] = Creator.Create(creator[name], context);

  return results;
};


#endif  // __MAX_CREATE
