#ifndef __CREATE_OBJECT
#define __CREATE_OBJECT

#include "max/max.js"
#include "max/patcher.js"

Creator.CreateObject = function(description, context) {
  var define = context.define || {};

  function Sub(v) {
    return (v in define) ? define[v] : v;
  };

  var args = description.concat(context.messages || []);

  var class = args[0].split(' ');
  for (var i = 0; i < class.length; ++i)
    class[i] = Sub(class[i]);

  if (class[0] == 'message') {
    args.push(['set'].concat(class.slice(1)));
    class = ['message'];
  }

  var x = context.x + args[1];
  var y = context.y + args[2];

  var maxobj = Max.patcher.newdefault.apply(Max.patcher, [x, y].concat(class));
  maxobj.rect = [x, y, x + args[3], y + args[4]];

  for (var i = 5; i < args.length; ++i) {
    var message = [];

    for (var j in args[i]) {
      var part = args[i][j];
      if (typeof(part) == 'string') {
        var index = part.indexOf('#');
        if (index >= 0)
          part = part.slice(0, index) + Sub(part.slice(index));

      }
      message.push(part);
    }
    if (message[0] == 'presentation_rect') {
      var r = message[1];
      var s = maxobj.rect;
      message[1] = [r[0] + s[0], r[1] + s[1], r[2] + s[2], r[3] + s[3]];
    }
    maxobj.message.apply(maxobj, message);
  }

  return maxobj;
};

#endif  // __CREATE_OBJECT
